Subject: 24.4; Emacs keyboard macros not working correctly
From: Leo <[email-masked]>
To: "[email-masked]" <[email-masked]>
Date: Wed, 29 Apr 2015 04:49:27 +0000 (UTC)
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,
I'm reporting the following bug that I found in Emacs. The textbelow lines up better with a monospace font. So if you want,
you could copy and paste it into an emacs buffer to see thetext aligned correctly.

Keyboard macros not working correctly
------------------------------------
Emacs has a problem when defining a keyboard macro using <f3>
and <f4>. If the macro contains a key sequence consisting of
a prefix key followed by an ASCII-character key, there is no
problem. However, if the key following the prefix key is
something other than an single character, such as a function
key, a keypad key, or an arrow key, the defined macro doesn't
work when it is subsequently executed with <f4>. And, there
is no error message. See details below.

Platform & Emacs version
------------------------
   GNU Emacs 24.4.1 (i686-pc-mingw32)
      of 2014-10-24 on LEG570
      Configured using: `configure --prefix=/c/usr'
   Windows 7 Home Premium (64-bit) - version 6.1.7600
   Intel Core i7 CPU - 1.73 GHz - 6 GB RAM
   ASUS Notebook G73Jw

Started Emacs at Command Prompt with this command:
--------------------------------------------------
   run_emacs.bat -Q

Executed this lisp code in *Scratch* buffer:
--------------------------------------------
   (progn
      (setq f5-key-map (make-sparse-keymap "F5-Key-prefix"))
      (define-key global-map [f5] f5-key-map)

      (define-key f5-key-map [(g)]   'forward-word)
      (define-key f5-key-map [f6]    'forward-word)
      (define-key f5-key-map [kp-4]  'forward-word)
      (define-key f5-key-map [right] 'forward-word)
   )

Case  This key
  #    sequence      Produces this result
----  --------      --------------------
  1   <f5> <g>      moves cursor forward by 1 word
  2   <f5> <f6>     moves cursor forward by 1 word
  3   <f5> <kp-4>   moves cursor forward by 1 word
  4   <f5> <right>  moves cursor forward by 1 word

Case   Define macro by using         Result when pressing
  #     this key sequence:             <f4> again:
----   ---------------------         --------------------
 11    <f3> <f5> <g> <f4>            moves cursor forward by 1 word
 12    <f3> <f5> <f6> <f4>           nothing
 13    <f3> <f5> <kp-4> <f4>         nothing
 14    <f3> <f5> <right> <f4>        nothing
 15    <f3> <f5> <f6> <right> <f4>   moves cursor forward by 1 word

Cases #12, #13, and #14 do not work at all. Nothing happens, and
there is no error message.

Case #11 is the only case where the macro works correctly.

Even though the macro in case #15 appears to work, it isn't working
correctly. It should move the cursor forward by one word AND one
character, but it only moves by one word. My guess is that, in
case #15 (as in case #12), the key <f6> is being ignored.

          - - - - - - - - - - - - - - - - - - -

In an effort to help debug case #15, I executed this
additional lisp code in the *scratch* buffer:

   (progn
      (defun define-macro-f8 () ""
         (interactive) (name-last-kbd-macro 'macro-f8))
      (defun insert-macro-f8 () ""
         (interactive) (insert-kbd-macro 'macro-f8))
      (define-key global-map [f7] 'define-macro-f8)
      (define-key global-map [f8] 'macro-f8)
      (define-key global-map [f9] 'insert-macro-f8)
   )

Whereupon, this key sequence puts the macro (from case #15) into <f8>:

   <f3> <f5> <f6> <right> <f4> <f7>

Then, every time I press <f8>, the cursor moves forward, as before, by
one word (NOT one word and one character, as it should). And then,
when I press <f9>, this macro definition is inserted into the buffer:

   (fset 'macro-f8 [f5 right])

As you can see, the <f6> key is missing.

          - - - - - - - - - - - - - - - - - - -

By the way, I tried something similar in Xemacs, and it has no
problem defining keyboard macros containing the same key sequences.
So, probably, my platform is not causing the problem.

Thank you.
Best regards,Leo